import React from 'react';
declare type Action = {
    type: 'showOverlay';
} | {
    type: 'hideOverlay';
} | {
    type: undefined;
};
declare type Dispatch = (action: Action) => void;
declare type State = {
    showOverlay?: boolean;
    route?: string;
};
declare type MinibookProviderProps = {
    children: React.ReactNode;
};
declare function MinibookProvider({ children }: MinibookProviderProps): JSX.Element;
declare function useMinibookState(): State;
declare function useMinibookDispatch(): Dispatch;
export { MinibookProvider, useMinibookState, useMinibookDispatch };
