function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React from 'react';
import { jsx as ___EmotionJSX } from "@emotion/react";
var MinibookStateContext = /*#__PURE__*/React.createContext(undefined);
var MinibookDispatchContext = /*#__PURE__*/React.createContext(undefined);
function minibookReducer(_state, action) {
  switch (action.type) {
    case 'showOverlay':
      {
        return {
          showOverlay: true
        };
      }
    case 'hideOverlay':
      {
        return {
          showOverlay: false
        };
      }
    default:
      {
        throw new Error("Unhandled action type: ".concat(action.type));
      }
  }
}
function MinibookProvider(_ref) {
  var children = _ref.children;
  var _React$useReducer = React.useReducer(minibookReducer, {
      showOverlay: false
    }),
    _React$useReducer2 = _slicedToArray(_React$useReducer, 2),
    state = _React$useReducer2[0],
    dispatch = _React$useReducer2[1];
  return ___EmotionJSX(MinibookStateContext.Provider, {
    value: state
  }, ___EmotionJSX(MinibookDispatchContext.Provider, {
    value: dispatch
  }, children));
}
function useMinibookState() {
  var context = React.useContext(MinibookStateContext);
  if (context === undefined) {
    throw new Error('useMinibookState must be used within a MinibookProvider');
  }
  return context;
}
function useMinibookDispatch() {
  var context = React.useContext(MinibookDispatchContext);
  if (context === undefined) {
    throw new Error('useMinibookDispatch must be used within a MinibookProvider');
  }
  return context;
}
export { MinibookProvider, useMinibookState, useMinibookDispatch };